import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import quadbase.reportdesigner.ReportAPI.QbReport;

public class StreamingDrillDown extends HttpServlet {
	static final long serialVersionUID = 1;

	@Override
	public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException,
			IOException
	{
		// Do not use EspressManager
		QbReport.setEspressManagerUsed(false);

		// Location of report template - Make sure to change this before trying out the example
		String reportTemplate = "StreamingDrillDown.pak";

		// Create QbReport object
		QbReport report = new QbReport(null, reportTemplate);

		// Set up connection information for RPTImageGenerator and DrillDownReportServlet
		report.setDynamicExport(true, "localhost", 8080);
		report.setServletDirectory("servlet/");

		// Export the report to DHTML and stream the bytes
		ByteArrayOutputStream reportBytes = new ByteArrayOutputStream();

		try {
			report.export(QbReport.DHTML, reportBytes); // where report is an object of type QbReport
			//			report.export(QbReport.PDF, reportBytes); 		// for PDF export
		} catch (Exception ex)
		{
			ex.printStackTrace();
		}

		res.setContentType("text/html"); // where res is the HttpServletResponse
		//		res.setContentType("application/pdf"); 	// where res is the HttpServletResponse
		res.setContentLength(reportBytes.size());

		OutputStream toClient = res.getOutputStream();
		reportBytes.writeTo(toClient);
		toClient.flush();
		toClient.close();
	}
}
